#include "troxgyro.h"
#define MAXBALLS 5000


typedef struct {
    double x,y,z;
    char c;
} Coord;


Coord * balllist=NULL; 
int ballindex=0;


void initgyro(void)
{
    balllist = (Coord *) malloc(MAXBALLS*sizeof(Coord));
    if (balllist==NULL) {
	printf("troxgyro: Could not get enough memory!\n");
	exit(1);
    }
}


void addtolist(Vector n, char c)
{
    balllist[ballindex].x=n.x;
    balllist[ballindex].y=n.y;
    balllist[ballindex].z=n.z;
    balllist[ballindex].c=c;
    ballindex++;
    if (ballindex>MAXBALLS) {
	printf("troxgyro: more balls than reserved memory!\n");
	exit(1);
    }
}


void sink(const int & p)
{
    int i;
    for (i=0; i<ballindex; i++) {
	if (balllist[i].c==p) {
	    balllist[i].x*=0.995;
	    balllist[i].y*=0.995;
	    balllist[i].z*=0.995;
	}
    }
}


bool iscollision(Vector n)
{
    register int i;
    register Vector d;
    register double s;
    register Coord * list;
    s=(float)getsmallballradius()*2.0-1.0;
    list=balllist;
    for (i=0; i<ballindex; i++) {
	d.x=(*list).x-n.x;
	if (fabs(d.x)<s) {
	    d.y=(*list).y-n.y;
	    if (fabs(d.y)<s) {
		d.z=(*list).z-n.z;
		if (fabs(d.z)<s) {
		    if ((d.x*d.x+d.y*d.y+d.z*d.z)<(s*s)) {return true;}
		}
	    }
	}
	list++;
    }
    return false;
}


void clearlist(void)
{
    ballindex=0;
}


void turnanddraw(Tripel t, int side)
{
    Vector m,n,v;
    register double sx,sy,sz, cx,cy,cz;
    register int i;
    Coord * list;
    sx=sin(t.wx); cx=cos(t.wx);
    sy=sin(t.wy); cy=cos(t.wy);
    sz=sin(t.wz); cz=cos(t.wz);
    list=balllist;
    for (i=0; i<ballindex; i++) {
	m.x=cz*(*list).x+sz*(*list).y;
	m.y=cz*(*list).y-sz*(*list).x;
	v.x=cy*m.x      +sy*(*list).z;
	n.z=cy*(*list).z-sy*m.x;
	v.y=cx*m.y      +sx*n.z;
	v.z=cx*n.z      -sx*m.y;
	drawsmallball((signed short)v.x,(signed short)v.y,(signed short)v.z,(*list).c,side);
	list++;
    }
}


int getballcount(void)
{
    return ballindex;
}
