// troxmath
// some "simple" mathematical functions.
// last changeg 1999-01-02
// Robin Gruber

#ifndef TROXMATH_H
#define TROXMATH_H

#include <stdlib.h>
#include <math.h>
#include <bool.h>

typedef struct {
    double x,y,z;
} Vector;

typedef struct {
    Vector y,z;
    double dx,dy;
    bool flip;
} World;

typedef struct {
    double wx,wy,wz;
} Tripel;


inline double sqr(const double &x)
{    
    return x*x;
}

inline signed int rnd(const int &x)
{
    return random()/(RAND_MAX/x);
}

inline Vector vect(const double &x,const double &y, const double &z)
{
    Vector v;
    v.x=x;
    v.y=y;
    v.z=z;
    return v;
}

inline Tripel trip(const double &x,const double &y, const double &z)
{
    Tripel v;
    v.wx=x;
    v.wy=y;
    v.wz=z;
    return v;
}

Vector rotate(const Vector &k, const Tripel &d);

Vector rerotate(const Vector &k, const Tripel &d);

Tripel whereis(const World &w);


#endif
